#include "typedef.h"

#include <stdio.h>
#include <string.h>

#include "object.h"
#include "opcode.h"
#include "class.h"
#include "showline.h"

extern FILE	*stdoutF;

Cshowline::Cshowline(void)
{
	m_F      = 0;
	m_classP = 0;
}

FILE *
Cshowline::showing(Cclass *classP)
{
	char	*filenameP;
	int		lth;

	if (m_classP != classP) {
		if (m_F) {
			fclose(m_F);
		}
		m_F = 0;
		if (filenameP = classP->m_filenameP) {
			lth = strlen(filenameP);
			if (lth > 6 && !strcmp(filenameP+lth-6, ".class")) {
				strcpy(filenameP+lth-5, "java");
				m_F = fopen(filenameP, "r");
				strcpy(filenameP+lth-5, "class");
				m_lineno = 1;
		}	}
		m_classP = classP;
	}
	return m_F;
}

void
Cshowline::show(int lineno)
{
	FILE	*F = m_F;
	int	c;

	if (lineno > 0) {
		if (m_lineno > lineno) {
			rewind(F);
			m_lineno = 1;
		}
		for (; m_lineno < lineno; ++m_lineno) {
			while ((c = fgetc(F)) != '\n') {
				if (c == EOF) {
					return;
		}	}	}
		++m_lineno;
		fprintf(stdoutF, "<i>%d: ", lineno);
		while ((c = fgetc(F)) != '\n' && c != EOF) {
			switch (c) {
			case '\r':
				continue;
			case '>':
				fputs("&gt;", stdoutF);
				continue;
			case '<':
				fputs("&lt;", stdoutF);
				continue;
			case '&':
				fputs("&amp;", stdoutF);
				continue;
			case '\t':
				c = ' ';
			}
			fputc(c, stdoutF);
		}
		fputs("</i>", stdoutF);
}	}

